.TH GSPREVIEW 1 "7 May 1992"
\" @(#)gspreview.man	1.7 (UKC) 30/5/92
\"
.SH NAME
.nh
gspreview \- Ghostscript/PostScript file previewer
\"
.SH SYNOPSIS
\fBgspreview\fP
[ \-display \fIdisplay_name\fP ]
[ other standard toolkit options ]
.in +.75in
.br
[ \-page \fIpage_number\fP ]
.br
[ [ \-res | \-resolution ] \fInumber\fP ]
.br
[ \-portrait | \-landscape | \-upsidedown | \-seascape ]
.br
[ \-paper \fIpaper_size\fP ]
.br
[ \-sizes "\fIlist_of_paper_sizes\fP" ]
.br
[ \-comments | +comments ]
.br
[ \-picasso ]
.br
[ filename | \- ]
.in -.75in
\"
.SH DESCRIPTION
\fIgspreview\fP is a previewer for the Ghostscript page markup language 
which closely resembles the PostScript language. \fIgspreview\fP is an X 
user interface to the Ghostscript interpreter which renders PostScript 
language files into an X window. The Ghostscript interpreter supports 
colour operators allowing output for colour PostScript printers to be 
previewed (both UNIRAS and \fIidraw\fP can generate colour pictures).
.LP
When run \fIgspreview\fP displays a large window containing a
scrollable previewing area and some push buttons. Each page of the
PostScript document being previewed is shown in this previewing area.
The scroll bars above and to the left of this area can be used to view
obscurred parts of the page. \fIgspreview\fP allows the user to flip
through each page of a file backwards or forwards and to go to
a specific page.  If a \fBfilename\fP is given on the command line it is
loaded as the initial file to preview.
.LP
\fIgspreview\fP recognizes files that conform to the PostScript 
structuring conventions and uses the given \fI%%\fP comments to separate 
the file into pages of output. Both \fIdvips\fP (for LaTeX/TeX) and 
\fIdlps\fP (for ditroff) produce PostScript which follow these 
commenting conventions and can therefore be easily viewed using 
\fIgspreview\fP. Hand-created and uncommented PostScript files can also 
be viewed using \fIgspreview\fP however you can only view each page in 
turn and cannot jump to particular pages or go backwards through the 
pages. This is not a major limitation however as most PostScript files 
of this form normal only produce a few pages each.
.LP
Whilst the initial page is being displayed and whenever a new page is 
being shown, the cursor in the main window changes from a pointing 
finger to that of a watch to show \fIgspreview\fP is busy rendering that 
page. The number of this page along with the total number of pages in 
the file (if known) and the name of the current file are given along the 
bottom of the main window. \fIgspreview\fP scans the input file for
PostScript comments, whilst it is doing this the page numbers are
highlighted in reverse video. When the scanning has finished the page
numbers are displayed in their original colours.
.LP
The "File" button when pressed displays a dialog box in which to 
select the name of a PostScript file to preview. Selecting a file can be
made in two ways, either the filename can be typed directly into the text
area at the top of the dialog box or it can be chosen from the scrollable
list of the contents of the current directory. This scrollable list is a
small directory browser. Each file is listed along with a "/" and/or a
"@" suffix to indicate if the file is directory or symbolic link.
Clicking on a directory entry will cause the list to be updated to show
the contents of that directory. The "../" entry points to the previous
directory in the hierarchy. The "./" entry points to the current
directory being listed and can be clicked on to refresh the list.
Clicking on a normal filename entry displays the full pathname of the
file in the text area above the list.
Double-clicking on a filename entry, typing a "Return" in the text area
or pressing the "Load File" button causes the file to be loaded. If the
file cannot be loaded an error message will be displayed underneath the
filename. If the file loaded is not a PostScript file the error window
will be popped up (see below).
.LP
The "Next" button advances through the file, the "Previous" button goes
back through the file. When the "Go To" button is pressed a separate
dialog box is displayed which allows the entry of a page number, either
directly using the keyboard or by clicking the mouse the first mouse
button on the up and down arrows. Pressing the "Okay" button causes the
chosen page (if it exists) to be displayed.
.LP
Moving through the pages can also be achieved using the mouse buttons or the
keyboard in the main previewing window. These controls are detailed in the
KEYBOARD\ CONTROLS and MOUSE\ CONTROLS sections below. They should be
familiar to users of the \fIxproof\fP and \fIxdvi\fP previewers.
.LP
A bell/beep will sound if you try to display a non-existent page, or in a
commented file, that page has not been reached by \fIgspreview\fP's page
scanner.
.LP
A file can be re-read by pressing \fBr\fP in the previewing area. This
causes the whole file to be read looking for comments and page breaks.
The first page is also redisplayed.
.LP
Pressing the "Scale" button pops up the Page Scaling dialog box. This
dialog box contains a list of "radio buttons" with which to set the size
of the output window in which the PostScript file is rendered.
\fIgspreview\fP tries to make the default window size the same as the
chosen page size, so that the output appears life size. However in some
cases this may be too large or too small for easy viewing. The output
window can therefore be set using this dialog box to half size, normal, twice
or to a custom size. A custom size can be set as either a percentage of
the default size or to a particular dots-per-inch resolution. When a
change is made the "Apply" and "Reset" buttons become active and can be
pressed to either apply the change or to reset it back to the previously
applied setting. Applying a change causes the currently displayed page
to be redisplayed using the new settings. Pressing the "Dismiss" button
pops down the dialog box.
.LP
Pressing the "Layout" button pops up the Page Display/Layout dialog box.
This dialog box contains a list of "radio buttons" with which to set the
orientation and size of the printed page. There are four orientation 
choices: portrait, landscape, upsidedown and seascape. The different 
page sizes available are shown in a scrollable list. A new page size is 
chosen by clicking on its entry in this list. When a change is made the 
"Apply" and "Reset" buttons become active and can be pressed to either 
apply the change or to reset it back to the previously applied setting. 
Applying a change causes the currently displayed page to be redisplayed 
using the new settings. Pressing the "Dismiss" button pops down the 
dialog box. The dialog box also contains an "Ignore Comments" toggle
button; toggling this to TRUE (a tick) causes \fIgspreview\fP to ignore
any comments in the next PostScript file loaded.
.LP
The "Quit" buttons exits gspreview immediately and can always be invoked
(pressing the \fBq\fP also works).
.SH OPTIONS
The following options in addition to standard X toolkit options can be
used on the command line:
.IP "\fB\-page\fP \fIpage number\fP
This options sets the initial page to be displayed upon startup and also
when the initial file is re-read. The page number given is the real page
rather than the label that may be printed on the page.
.IP "\fB\-paper\fP \fIpaper size\fP
This option sets the initial size of the "paper tray" used for output. 
The name of the paper size should be one of the available sizes shown in 
the Page Size list: e\.g\. \fBA4\fP or \fBLetter\fP.
.IP "\fB\-res\fP \fInumber\fP
.IP "\fB\-resolution\fP \fInumber\fP
These options set the resolution of the output window used for the 
rendering of pages. The \fInumber\fP can be a positive or negative 
integer. If it is less than zero the absolute value of the number is 
used as a percentage of the screen's resolution, therefore -200 will 
double the size of the default page size. If the given number greater 
than zero it is used as the dots-per-inch resolution of the output 
window. If the number if zero the screen's resolution is used.
.IP "\fB\-sizes\fP \fIlist of paper sizes\fP
This option can be used to set the list of available "paper tray" sizes. 
The list is given as a quoted string of whitespace separated definitions 
of different page sizes. The format of each size definition is 
"\fBsize_name\fP=\fIwidth\fPx\fIheight\fP" where the width and height is 
given in millimeters. The height should be larger than the width, i\.e\. 
in its portrait orientation.
.IP \fB\-portrait\fP
.IP \fB\-landscape\fP
.IP \fB\-upsidedown\fP
.IP \fB\-seascape\fP
These flags set the page orientation to one of four different 
orientations. The initial orientation can be changed interactively 
using the Page Display/Layout dialog box.
.IP \fB\-comments\fP
.IP \fB+comments\fP
These options turn off or turn on the interpreting of commented 
PostScript files. Turning off comments means that only a forward 
movement through a file is possible and full page turning is not 
available. The default is to process comments.
.IP \fB\-picasso\fP
The \fB\-picasso\fP flag adds a clip path around each displayed page 
that clips the output to that of the printable area of the QMS colour 
PostScript printer.
.IP \fB\-\fP
If \fIgspreview\fP is invoked with the \fB\-\fP flag it reads PostScript 
from the terminal's standard input. This allows input of PostScript 
commands by hand for debugging/experimenting. PostScript output (from 
other commands) can be directly piped into \fIgspreview\fP. In this case 
the \fB\-\fP flag is not required.
\"
.SH "ERRORS"
Any errors found in the 
PostScript file are displayed in another dialog box which is popped up 
automatically when an error occurs. Pressing the "Acknowledged" button 
in the error dialog clears the current error and hides the dialog.
.LP
The 
error is shown at the top of the error dialog and the three Ghostscript
interpreter stacks are shown in the Operand Stack, Execution Stack and the
Dictionary Stack. The items in these stacks are listed from top to bottom
order showing their contents when the error occurred. They can be used to
help debug the file.
.LP
The error dialog can be displayed at anytime by typing \fBe\fP in the
previewing window.
\"
.SH "OUTPUT"
Any output generated by the file (using the "print" operand) or by the
Ghostscript interpreter (these messages are prefixed with "GS>") are
displayed in the Output dialog box. This dialog is automatically 
displayed whenever new output is generated by the file (Ghostscript 
interpreter messages do not cause the dialog to popup). These messages 
and text output can be cleared by pressing the "Acknowledged" button 
which also pops down the dialog.
.LP
The output dialog can be displayed at 
anytime by typing \fBo\fP in the previewing window.
\"
.SH "KEYBOARD CONTROLS"
All the functions of \fIgspreview\fP can be 
invoked using the keyboard. The following is list of the characters that 
can be typed to invoke the desired function. If a number is typed before 
one of these characters the function is repeated that number of times, 
for example to move on three pages you can type \fB3n\fP, to display 
page five type \fB5g\fP or \fB5=\fP.
.LP
[0-9]+	: page count
.br
f, n, d, SPACE, RETURN, +	: forwards "page count" pages
.br
b, p, u, -	: backwards "page count" pages
.br
g, =	: jump to "page count" page
.br
G, >, $	: jump to last page
.br
<, ^	: jump to first page
.br
r	: Re-read current file, restarts at the first page
.br
l	: Popup File load dialog box
.br
e	: Popup Errors dialog box
.br
o	: Popup Output Text dialog box
.br
S	: Popup Scaling dialog box
.br
O	: Popup Page Options/Layout dialog box
.br
q	: quit
\"
.SH "MOUSE CONTROLS"
The buttons on the mouse have been bound to the 
following functions:
.LP
Button 1	: backwards one page
.br
Button 2	: forwards one page
.br
Button 3	: no function
\"
.SH "APPLICATION RESOURCES"
The following application resources are defined by \fIgspreview\fP and
can be set in an application defaults file or using \fIxrdb\fP:
.IP "\fBpicassoPrinter\fP,    \fIColourPrinter\fP
A boolean resource which can be set to either TRUE or FALSE to indicate 
when to add a clip path to show how output is clipped on a QMS100 colour 
printer.
.IP "\fBignoreComments\fP,    \fIIgnoreComments\fP
A boolean resource which defaults to FALSE. Setting this resource to 
TRUE stops \fIgspreview\fP interpreting PostScript comments and turns 
off intelligent page turning.
.IP "\fBpageLayout\fP,    \fIPageLayout\fP
This resource can be set to: \fIlandscape, portrait, upsidedown\fP or 
\fIseascape\fP. The default is \fIportrait\fP. It sets the orientation 
of the rendered page on the screen.
.IP "\fBpageResolution\fP,    \fIPageResolution\fP
This resource sets the resolution of the rendered page. If the number if 
less than zero it is taken as a percentage of the screen resolution. If 
the number is zero the screen's resolution is used. If the number is 
greater than zero it is taken as the resolution of the rendering page.
.IP "\fBuseStdin\fP,    \fIUseStdin\fP
This boolean resource, if TRUE, indictates that PostScript commands are 
read directly from the standard input rather than a file.
.IP "\fBpaperSizes\fP,    \fIPaperSizes\fP
This resource is set to a string describing the sizes (in millimeters) 
of different paper trays. The syntax is 
"\fIsize_name\fP=\fIwidth\fPx\fIheight\fP" and the default is "Letter=216x279
A5=148x210 A4=210x297 A3=297x420". A 
particular size of paper can be set using the following resource.
.IP "\fBpaperTray\fP,    \fIPaperTray\fP
This resource sets the size of the rendering page to a particular size 
of paper, e\.g\. "A4".
\"
.SH "ENVIRONMENT VARIABLES"
DISPLAY \- default X Server to display 
previewer on
.\"
.SH SIGNALS
Sending a HUP signal to \fIgspreview\fP will 
cause it to re-read the current file.
\"
.SH "SEE ALSO"
\fIdvips\fP(1), 
\fIdlps\fP(1), \fIidraw\fP(1), \fIxproof\fP(1), \fIxdvi\fP(1),
\fIxrdb\fP(1).
\"
.SH BUGS
There may be slight differences between the the full Adobe 
PostScript language and the Ghostscript language.
.br
The correct handling 
of "out of memory" errors from the X server does not work and is 
currently disabled.
\"
.SH AUTHORS
The Ghostscript interpreter and X device 
driver are written by L\. Peter Deutsch (ghost@aladdin.com). Ghostscript 
is distributed by the Free Software Foundation, Inc\. under the GNU 
public license.
.br
The previewer's user interface was created by Richard 
Hesketh (rlh2@ukc.ac.uk), University of Kent at Canterbury, January 
1991 (second release May 1992).
